<?php
//YANMAH2 - Yet ANother Mobile Accelerated HatenaHaiku
//(c) 2010 YANMAH2 project
//This program is freesoftware. you can redistribute it and/ormodify it under the terms of the [GNU Affero GPL v3](http://www.gnu.org/licenses/agpl.html).
?>
<?php
define("HELLO","world");
require_once "product_definitions.php";
require_once "configurable_variables.php";
?>
<?php
ini_set('session.gc_maxlifetime', $session_file_lifetime);
session_set_cookie_params($session_cookie_expire, dirname($_SERVER['SCRIPT_NAME']) . '/', $_SERVER["SERVER_NAME"]);
if ($custom_session_save_path != 'default'){
	session_save_path($custom_session_save_path);
}
session_start();
session_regenerate_id(TRUE);
?>
<?php
if ($extra_include_path != "default"){
	$default_include_path = ini_get("include_path");
	ini_set('include_path', ".:{$extra_include_path}:{$default_include_path}");
}
$http_url_regexp = 's?https?:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+';
$http_host_regexp = 's?https?:\/\/[-_.!~*\'()a-zA-Z0-9;?:@&=+$,%#]+\/*';
$http_path_regexp = '[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]*';
mb_regex_encoding("UTF-8");
$page_head = 'ログイン';
?>
<?php //セキュリティのための前処理。
//NULL バイトの入力を弾く
function checkNull($array){
	if (is_array($array)){
		return array_map('checkNull', $array);
	}
	if (preg_match('/\0/', $array)){
		echo "NULL ぽ";
		exit();
	}
}
checkNull($_GET);
checkNull($_POST);
checkNull($_COOKIE);
//不正なはてなID
//正しいはてなID＝アルファベットで始まり、アルファベットか数字で終わる3文字以上､32文字以内の半角英数字
function checkId($element){
	if (preg_match("/^[a-zA-Z]{1}[-_a-zA-Z1234567890]{1,30}[a-zA-Z1234567890]{1}$/u" ,$element) == 0){
		echo "なにそれこわい\n(YANMAH2: はてなIDの指定に関するエラー)";
		exit();
	}
}
if ($_POST["hatenaid"] != ''){
	checkId($_POST["hatenaid"]);
}
function checkHttpUrl($element){
	if (preg_match("/^s?https?:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+$/u", $element) == 0){
		echo ':return パラメータの値が不正の様な気がします。';
		exit();
	}
}
if ($_GET['return'] != ''){
	checkHttpUrl($_GET['return']);
}
?>
<?php
if ($_GET['return'] != '' && mb_ereg_match("^{$http_url_regexp}$", $_GET['return'])){
	$_SESSION['return'] = $_GET['return'];
}
?>
<?php
if ($_GET['log'] == 'out'){
	$_SESSION = array();
	setcookie(session_name(),'',time()-999, dirname($_SERVER['SCRIPT_NAME']) . '/');
	session_destroy();
	$page_head = 'ログアウト';
}
?>
<?php
//var_dump($_POST['login']);
require_once "HTTP/Request.php";
$error = '';
if ($_POST['login'] == 'try'){
	if (!isset($_SESSION['auth'])){
		$_SESSION['auth'] = FALSE;
	}
}
if (isset($_POST['hatenaid']) && isset($_POST['password'])){
	if (mb_strpos($_POST['password'], '@') != FALSE){
		$atmark_pos = mb_strpos($_POST['password'], '@');
		$_SESSION['password'] = mb_substr($_POST['password'], 0, $atmark_pos);
	} else{
		$_SESSION['password'] = $_POST['password'];
	}
	$_SESSION['hatenaid'] = $_POST['hatenaid'];
	$inquiry_url = 'http://h.hatena.ne.jp/api/statuses/user_timeline.json';
	$i_req =& new HTTP_Request($inquiry_url);
	$i_req->setBasicAuth($_POST['hatenaid'], $_POST['password']);
	if(!PEAR::isError($i_req->sendRequest())) {
		$json = $i_req->getResponseBody();
		$baked_json = json_decode($json, TRUE);
		//var_dump($baked_json);
		if (is_array($baked_json)){
			$_SESSION['auth'] = TRUE;
		} else {
			$error = '<p>入力された値が間違っているか、はてながしなもんかもしれません。</p><blockquote>' . $json . '</blockquote>';
			$_SESSION['auth'] = FALSE;
		}
	}
	
} elseif ($_SESSION['auth'] === FALSE){
	$error = '<p>なんかのエラーです。</p>';
}
?>
<?php
echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta http-equiv="Content-Script-Type" content="text/javascript" />
	<?php echo "<title>{$page_head} - {$site_name}{$site_name_caption}</title>\n"; ?>
	<link rel="stylesheet" href="./found.css" />
	<link rel="icon" href="./favicon.ico" type="image/vnd.microsoft.icon" />
	<link rel="shortcut icon" href="./favicon.ico" type="image/vnd.microsoft.icon" /></head>
<body>
<div id="header"><h1>
<?php
echo $page_head;
?>
</h1></div>
<hr />
<?php
//var_dump($_SERVER['SERVER_NAME']);
//echo dirname($_SERVER['SCRIPT_NAME']);
//var_dump($_SESSION['password']);
//var_dump($session_cookie_expire);
if ($error != ''){
	echo $error;
}
if ($_SESSION['auth'] === TRUE){
	$session_hatenaid = htmlspecialchars($_SESSION['hatenaid'], ENT_QUOTES);
	echo '<p>ようこそ。あなたは <a href="./entries.php?user=' . $session_hatenaid . '" class="hatena-id">id:' . $session_hatenaid . '</a> としてはてなハイクに参加します。もし間違っている場合は、一旦<a href="./login.php?log=out" class="navigation-link">ログアウト</a>してください。</p>';
}
if ($_GET['log'] == 'out'){
	echo '<p>ログアウトしました。またね。</p>';
}
?>
<?php
if ($_SESSION['auth'] != TRUE){
	echo <<<EOL
<div class="login-form">
<form action="./login.php" method="post">
<dl>
<dt><label for="hatenaid">はてなID</label></dt><dd><input type="text" name="hatenaid" id="hatenaid" value="" /></dd>
<dt><label for="password">投稿用アドレス</label></dt><dd><input type="password" name="password" id="password" value="" /></dd>
</dl>
<input type="hidden" name="login" value="try" />
<input type="submit" value="ログイン" />
</form>
</div>
EOL;
	echo $login_notice;
}
?>
<hr />
<div class="navigation-menu">
<ul>
<?php
if ($_SESSION['auth'] === TRUE){
	if ($_SESSION['return'] != ''){
		echo '<li><a href="' . $_SESSION['return'] . '">元のページ</a>に戻る</li>';
		$_SESSION['return'] = '';
	}
	echo '<li><a href="./entries.php?following=' . $_SESSION['hatenaid'] . '" class="navigation-link" accesskey="5">' . $_SESSION['hatenaid'] . ' のアンテナ</a>へ<span class="access-key">(5)</span></li>';
}
	echo "<li><a href=\"./index.php\" class=\"navigation-link\" accesskey=\"0\">インデックス</a>へ<span class=\"access-key\">(0)</span></li>";
	echo "<li><a href=\"./entries.php\" class=\"navigation-link\" accesskey=\"2\">みんなの最新エントリー</a>へ<span class=\"access-key\">(2)</span></li>";
	echo '<li><a href="./keywords.php" class="navigation-link" accesskey="8">キーワード一覧／検索</a>へ<span class="access-key">(8)</span></li>';
?>
</ul>
</div>
<hr />
<?php
echo $footer;
?>
</body>
</html>
