<?php
//YANMAH2 - Yet ANother Mobile Accelerated HatenaHaiku
//(c) 2010 YANMAH2 project
//This program is freesoftware. you can redistribute it and/ormodify it under the terms of the [GNU Affero GPL v3](http://www.gnu.org/licenses/agpl.html).
?>
<?php
define("HELLO","world");
require_once "product_definitions.php";
require_once "configurable_variables.php";
?>
<?php
session_set_cookie_params($session_cookie_expire, dirname($_SERVER['SCRIPT_NAME']) . '/', $_SERVER["SERVER_NAME"]);
if ($custom_session_save_path != 'default'){
	session_save_path($custom_session_save_path);
}
session_start();
session_regenerate_id(TRUE);
?>
<?php
if ($extra_include_path != "default"){
	$default_include_path = ini_get("include_path");
	ini_set('include_path', ".:{$extra_include_path}:{$default_include_path}");
}
$selfcall = htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES);
$safequery = htmlspecialchars($_SERVER["QUERY_STRING"], ENT_QUOTES);
$http_url_regexp = 's?https?:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+';
$http_host_regexp = 's?https?:\/\/[-_.!~*\'()a-zA-Z0-9;?:@&=+$,%#]+\/*';
$http_path_regexp = '[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]*';
mb_regex_encoding("UTF-8");
?>
<?php
//NULL バイトの入力を弾く
function checkNull($array){
	if (is_array($array)){
		return array_map('checkNull', $array);
	}
	if (preg_match('/\0/', $array)){
		echo "NULL ぽ";
		exit();
	}
}
checkNull($_GET);
checkNull($_POST);
checkNull($_COOKIE);
//entry id
function checkEntryid($element){
	if (preg_match("/^[1234567890]+$/u",$element) === FALSE){
		echo "エントリさーん、どこですかー\n(YANMAH2: Entry ID に関するエラー)";
		exit();
	}
}
if ($_GET[entry] != ''){
	checkEntryid($_GET[entry]);
}
//不正なはてなID
//正しいはてなID＝アルファベットで始まり、アルファベットか数字で終わる3文字以上､32文字以内の半角英数字
function checkId($element){
	if (preg_match("/^[a-zA-Z]{1}[-_a-zA-Z1234567890]{1,30}[a-zA-Z1234567890]{1}$/u" ,$element) == 0){
		echo "なにそれこわい\n(YANMAH2: はてなIDの指定に関するエラー)";
		exit();
	}
}
if ($_GET["user"] != ''){
	checkId($_GET["user"]);
}
//長すぎる keyword
function checkKeyword($element){
	if (strlen(bin2hex($element)) > 511){
		echo "キーワードが長すぎて入らないです…\n(YANMAH2: キーワードの指定に関するエラー)";
		exit();
	}
}
if ($_GET["keyword"] != ''){
	checkKeyword($_GET["keyword"]);
}
?>
<?php
//投稿処理の呼び出し。
//var_dump($_POST);
if ($_POST['posting'] == 'try'){
//	var_dump($_POST['posting']);
	require 'post_processor.php';
	header('HTTP/1.1 303 See Other');
	header('Location: ' . $_POST['return']);
	exit();

}
//スター処理の呼び出し。
if ($_POST['posting'] != 'try' && $_POST['star'] == 'add'){
	require 'post_processor.php';
	header('HTTP/1.1 303 See Other');
	header('Location: ' . $_POST['return']);
	exit();
}
?>
<?php
echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
?>
<?php
require_once "HTTP/Request.php";
if ($_GET[entry] != ''){
	$get_entry = $_GET[entry];
	$json_url = "http://h.hatena.ne.jp/api/statuses/show/{$get_entry}.json";
}
if ($_GET['user'] != ''){
	$get_user = $_GET['user'];
	$page_head = $get_user . ' さんのエントリー';
	$official = $haiku_official_url . $get_user . '/' . $get_entry;
	$self_anchor = 'http://' . $_SERVER['SERVER_NAME'] . $selfcall . '?entry=' . $get_entry . '&amp;user=' . $get_user;
	$self_anchor_possibly_with_pagenum = $self_anchor;
}	elseif ($_GET['user'] == ''){
	$page_head = 'エントリー';
	$official = $haiku_official_url . 'entry' . '/' . $get_entry;
	$self_anchor = 'http://' . $_SERVER['SERVER_NAME'] . $selfcall . '?entry=' . $get_entry;
	$self_anchor_possibly_with_pagenum = $self_anchor;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta http-equiv="Content-Script-Type" content="text/javascript" />
	<?php echo "<title>{$page_head} - {$site_name}{$site_name_caption}</title>\n"; ?>
	<link rel="stylesheet" href="./found.css" />
	<link rel="icon" href="./favicon.ico" type="image/vnd.microsoft.icon" />
	<link rel="shortcut icon" href="./favicon.ico" type="image/vnd.microsoft.icon" /></head>
<body>
<?php
//var_dump($_GET);
echo "<div id=\"header\">\n";
echo "<h1 id=\"entries-head\" class=\"head1\">{$page_head} <a href=\"{$official}\" class=\"to-original-link\">&nbsp;‡&nbsp;</a></h1>\n<hr />";
echo "</div>\n";
if ($_SESSION['auth'] === TRUE){
	if ($_SESSION['post_result'] == 'success'){
		echo '<span>' . $_SESSION['post_result_mes'] . '</span>';
	}
	if ($_SESSION['post_result'] == 'failed'){
		echo '<span>' . $_SESSION['post_result_mes'] . '</span>';
		echo $_SESSION['post_error'];
	}
//	echo '</div>';
	$_SESSION['post_result'] = '';
	$_SESSION['post_result_mes'] = '';
	$_SESSION['post_error'] = '';
}
?>
<div class="contents">
<?php
$request_url = $json_url;
$req =& new HTTP_Request($request_url);
if (!PEAR::isError($req->sendRequest())) {
	$json = $req->getResponseBody();
	$contents = json_decode($json,true);
	if (is_array($contents)){
	}	else {
			echo "<blockquote>{$json}</blockquote>";
			exit();
		}
	$entry_processor_mode = "entry";
	$val = $contents;
	require 'entry_processor.php';
	if ($contents['replies'][0]['id'] != ''){
		echo '<dl><dt>リプライ</dt>';
		echo '<dd>';
		foreach($contents['replies'] as $val){
			$val['keyword'] = $_GET['keyword'];
			require 'entry_processor.php';
		}
		echo '</dd>';
		echo '</dl>';
	}
}
?>
<?php
if ($_SESSION['auth'] === TRUE){
	echo '<dl class="post-box">';
	echo '<dt>リプライする</dt><dd>';
	echo <<<EOL
<form method="post" action="" enctype="application/x-www-form-urlencoded">
<textarea id="post-text" name="status" rows="3" cols="20"></textarea><br />
<input type="hidden" name="posting" value="try" />
<input type="hidden" name="return" value="{$self_anchor_possibly_with_pagenum}" />
<input type="hidden" name="in_reply_to_status_id" value="{$get_entry}" />
<input type="submit" id="post-haiku" value="Haiku!" />
<label for="post-from"> from </label><input type="text" id="post-from" name="source" value="{$product_name_abbr}" maxlength="170" />
</form>
EOL;
	echo '</dd>';
/*	if ($_SESSION['post_result'] == 'success'){
		echo '<dd>' . $_SESSION['post_result_mes'] . '</dd>';
	}
	if ($_SESSION['post_result'] == 'failed'){
		echo '<dd>' . $_SESSION['post_result_mes'] . '</dd>';
		echo '<dd>' . $_SESSION['post_error'] . '</dd>';
	}*/
	echo '</dl>';
/*	$_SESSION['post_result'] = '';
	$_SESSION['post_result_mes'] = '';
	$_SESSION['post_error'] = '';*/
}
?>
</div>
<ul>
<li><a href="./index.php" class="navigation-link" accesskey="0">インデックス</a>へ<span class="access-key">(0)</span></li>
<li><a href="./entries.php" class="navigation-link" accesskey="2">みんなの最新エントリー</a>へ<span class="access-key">(2)</span></li>
<li><a href="./keywords.php" class="navigation-link" accesskey="8">キーワード一覧／検索</a>へ<span class="access-key">(8)</span></li>
<?php
if ($_SESSION['auth'] === TRUE){
	echo '<li><a href="./login.php?log=out" class="navigation-link" accesskey="9">ログアウト</a>する<span class="access-key">(9)</span>';
} else {
	echo '<li><a href="./login.php?return=' . rawurlencode($self_anchor_possibly_with_pagenum) . '" class="navigation-link" accesskey="9">ログイン</a>する<span class="access-key">(9)</span></li>';
}
?>
</ul>
<hr />
<?php
echo $footer;
?>
</body>
</html>
